part of 'account_bloc.dart';

@immutable
abstract class AccountEvent extends Equatable {
  const AccountEvent();

  @override
  List<Object> get props => [];
}

class AccountChangeCustomer extends AccountEvent {
  final Customer customer;

  const AccountChangeCustomer({this.customer});

  @override
  List<Object> get props => [customer];
}

class AccountLogout extends AccountEvent {
  final Customer customer;

  const AccountLogout({this.customer});

  @override
  List<Object> get props => [customer];

}

class AccountLogin extends AccountEvent {
  final Customer customer;

  const AccountLogin({this.customer});

  @override
  List<Object> get props => [customer];
}

class AccountLogInFinished extends AccountEvent {
  final Customer customer;

  const AccountLogInFinished({this.customer});

  @override
  List<Object> get props => [customer];
}